﻿using System;


namespace FireBus.Contracts
{
	[Serializable]
	public class ExtensionName : ValueObject<String>
	{
		public ExtensionName(String name)
		{
			if (String.IsNullOrEmpty(name))
			{
				throw new ArgumentNullException("name");
			}
			Value = name;
		}

		public static implicit operator String(ExtensionName name)
		{
			return ToString(name);
		}

		public static String ToString(ExtensionName name)
		{
			return name == null ? null : name.Value;
		}

		public static implicit operator ExtensionName(String name)
		{
			return new ExtensionName(name);
		}
	}
}
