﻿using System;


namespace FireBus.Contracts
{
	public class NotifyEventArgs<TEvent> : EventArgs
		where TEvent : class
	{
		private readonly TEvent _Arguments;


		public TEvent Arguments
		{
			get { return _Arguments; }
		}


		public NotifyEventArgs(TEvent arguments)
		{
			if (arguments == null)
			{
				throw new ArgumentNullException("arguments");
			}
			_Arguments = arguments;
		}
	}
}
