﻿using System;
using System.Collections.Generic;
using System.Globalization;


namespace FireBus.Shell.ExtensionManager
{
	public class LoadCommand : ICommand
	{
		private readonly Extension _Extension;


		public LoadCommand(Extension extension)
		{
			if (extension == null)
			{
				throw new ArgumentNullException("extension");
			}
			_Extension = extension;
		}


		public String Name
		{
			get { return "load"; }
		}

		public String Description
		{
			get
			{
				return
					@"Loads extension by given name.
Example:
load ExtensionManager";
			}
		}

		public String Execute(IList<String> args)
		{
			if (args == null)
			{
				throw new ArgumentNullException("args");
			}
			if (args.Count < 1)
			{
				return "Invalid arguments";
			}
			var extensionName = args[0];

			_Extension.LoadExtension(extensionName);

			return
				String.Format(
					CultureInfo.InvariantCulture,
					"Extension {0} was marked for load",
					extensionName);
		}
	}
}
