﻿using System;
using System.Collections.Generic;


namespace FireBus.Shell.Contracts
{
	[Serializable]
	public class CommandRequest
	{
		public ShellCommandName Command { get; private set; }

		public IList<String> Arguments { get; private set; }


		public CommandRequest(ShellCommandName command, IEnumerable<String> args)
		{
			if (command == null)
			{
				throw new ArgumentNullException("command");
			}
			Command = command;
			Arguments = args == null ? new String[0] : new List<String>(args).ToArray();
		}
	}
}
