﻿using System;

using FireBus.Contracts;


namespace FireBus.Shell.Contracts
{
	[Serializable]
	public class ShellCommandName : ValueObject<String>
	{
		public ShellCommandName(String name)
		{
			if (String.IsNullOrEmpty(name))
			{
				throw new ArgumentNullException("name");
			}
			Value = name;
		}

		public static implicit operator String(ShellCommandName name)
		{
			return ToString(name);
		}

		public static String ToString(ShellCommandName name)
		{
			return name == null ? null : name.Value;
		}

		public static implicit operator ShellCommandName(String name)
		{
			return new ShellCommandName(name);
		}
	}
}
