﻿using System;


namespace FireBus.UnitTest.Contracts
{
	[Serializable]
	public class LogMessageEvent
	{
		private readonly DateTime _Occured;

		private readonly String _Message;

		private readonly String _Source;

		private readonly LogMessageType _Type;


		public String Message
		{
			get { return _Message; }
		}

		public String Source
		{
			get { return _Source; }
		}

		public LogMessageType Type
		{
			get { return _Type; }
		}

		public DateTime Occured
		{
			get { return _Occured; }
		}


		public LogMessageEvent(
			String message, String source, LogMessageType type, DateTime occured)
		{
			_Message = message;
			_Source = source;
			_Type = type;
			_Occured = occured;
		}
	}
}
