﻿using System;

using FireBus.Contracts;


namespace FireBus.UnitTest.Contracts
{
	[Serializable]
	public class StartupEvent
	{
		private readonly ExtensionName _Name;

		private readonly ILogStorage _Storage;


		public ExtensionName Name
		{
			get { return _Name; }
		}

		public ILogStorage Storage
		{
			get { return _Storage; }
		}


		public StartupEvent(ExtensionName name, ILogStorage storage)
		{
			if (name == null)
			{
				throw new ArgumentNullException("name");
			}
			if (storage == null)
			{
				throw new ArgumentNullException("storage");
			}
			_Name = name;
			_Storage = storage;
		}
	}
}
