﻿using System;

using FireBus.Contracts;


namespace FireBus.UnitTest.Contracts
{
	[Serializable]
	public class StartupWithHostEvent : StartupEvent
	{
		private readonly IHost _Host;

		public IHost Host
		{
			get { return _Host; }
		}


		public StartupWithHostEvent(IHost host, ExtensionName extensionName, ILogStorage logStorage)
			: base(extensionName, logStorage)
		{
			if (host == null)
			{
				throw new ArgumentNullException("host");
			}
			_Host = host;
		}
	}
}
