﻿using System;

using FireBus.Contracts;
using FireBus.UnitTest.Contracts;


namespace FireBus.UnitTest.Extensions
{
	public class EventListenerExtension :
		IEventListener<StartupWithHostEvent>,
		IEventListener<AnUnknownEvent>
	{
		private ILogStorage _Storage;

		private ExtensionName _Name;


		public void OnEvent(AnUnknownEvent args)
		{
			_Storage.Push(
				_Name,
				new LogMessageEvent(
					args.Text, String.Empty, LogMessageType.Notification, DateTime.Now));
		}

		public void OnEvent(StartupWithHostEvent args)
		{
			_Storage = args.Storage;
			_Name = args.Name;
		}
	}
}
