﻿using System;

using FireBus.Contracts;
using FireBus.UnitTest.Contracts;


namespace FireBus.UnitTest.Extensions
{
	public class StringConverterExtension :
		IRequestListener<StringConversionRequest, String>,
		IRequestSender<ConvertRequest, ConvertResponse>
	{
		public event SendEventHandler<ConvertRequest, ConvertResponse> Send;

		public String OnRequest(StringConversionRequest request)
		{
			var output = request.Input;
			if (Send != null)
			{
				var args = new SendEventArgs<ConvertRequest, ConvertResponse>(
					request.Conversion, new ConvertRequest(request.Input));
				Send(this, args);
				var response = args.Responses.First;
				if (response != null)
				{
					output = response.Output;
				}
			}
			return output;
		}
	}
}
