﻿using FireBus.Contracts;
using FireBus.Core;
using FireBus.Isolation;


namespace FireBus.UnitTest.Fixtures.Hosts
{
	public class DefaultTestHost : Host
	{
		private static readonly IMessageAccessor _MessageAccessor
			= new ResourcesMessageAccessor();


		public DefaultTestHost()
			: base(new TestConfiguration())
		{
			
		}

		public void AddLog(ExtensionName name)
		{
			var log =
				new ExtensionToken(
					new ExtensionName(name),
					new ExtensionPath(
						@"..\..\..\FireBus.UnitTest.Extensions\bin\Debug\"),
					new TypeName("FireBus.UnitTest.Extensions.LogExtension, FireBus.UnitTest.Extensions, Version=0.1.0.0"));
			AddExtension(log);
		}

		public void AddUpperCaseConverter(ExtensionName name)
		{
			var token =
				new ExtensionToken(
					new ExtensionName(name),
					new ExtensionPath(
						@"..\..\..\FireBus.UnitTest.Extensions\bin\Debug\"),
					new TypeName("FireBus.UnitTest.Extensions.UpperCaseConverterExtension, FireBus.UnitTest.Extensions, Version=0.1.0.0"));
			AddExtension(token);
		}

		public void AddStringConverter(ExtensionName name)
		{
			var token =
				new ExtensionToken(
					new ExtensionName(name),
					new ExtensionPath(
						@"..\..\..\FireBus.UnitTest.Extensions\bin\Debug\"),
					new TypeName("FireBus.UnitTest.Extensions.StringConverterExtension, FireBus.UnitTest.Extensions, Version=0.1.0.0"));
			AddExtension(token);
		}
	}
}
